N=10^4;d=5;
A=fc_linalg3D.random.randnsympd(N,d);
fprintf('[fc_linalg3D] Cholesky factorization with A a %d-by-%d-by-%d array\n',N,d,d)
fprintf('[fc_linalg3D] functions fc_linalg3D.fact.cholesky_*\n')
error=@(o1) max(abs(o1(:)));

Error=@(B) error(fc_linalg3D.mtimes(B,fc_linalg3D.ctranspose(B))-A);

B=fc_linalg3D.fact.cholesky_Ref(A);

E=fc_linalg3D.mtimes(B,fc_linalg3D.ctranspose(B))-A;
fprintf('* [Ref] fc_linalg3D.fact.cholesky_Ref \n')
fprintf('        |B*B^*-A|      : %.4e\n',Error(B));


versions={'Cpt','Mat','Vec'};

for v=versions
  ver=v{1};
  eval(['fun=@(A) fc_linalg3D.fact.cholesky_',ver,'(A);']);
  B1=fun(A);
  fprintf('* [%s] fc_linalg3D.fact.cholesky_%s \n',ver,ver)
  fprintf('       |B*B^*-A|       : %.4e\n',Error(B1));
  fprintf('       |B[Ref]-B[%s]| : %.4e\n',ver,error(abs(B-B1)));
end
