function B=cholesky_Mat(A)
% A : N-by-d-by-d, symmetric positive definite matrices
  assert(fc_linalg3D.is3Darray(A));
  N=size(A,1);d=size(A,2);
  assert(size(A,3)==d);
  B=zeros(N,d,d);
  for k=1:N
    B(k,:,:)=fc_linalg3D.fact.cholesky(squeeze(A(k,:,:)));
  end
end
