function B=cholesky_Spa(A)
% A : N-by-d-by-d, symmetric definite positve
  assert(fc_linalg3D.is3Darray(A));
  [N,m,n]=size(A);
  assert(m==n);
  spA=fc_linalg3D.amat2sparse(A);
  spL=chol(spA)';
  B=fc_linalg3D.sparse2amat(spL,N,m,m);
end
