function C=mtimes_Cpt(X,Y)
% function C=aXpbY_Cpt(a,X,b,Y)
%   returns C=a*X+b*Y
  assert( fc_linalg3D.is3Darray(X) || fc_linalg3D.is3Darray(Y) )
  if isscalar(X) || isscalar(Y)==1, C=X*Y;return;end % X or Y is constant (to improve performance)
%    [getX,getY,dim]=fc_linalg3D.getCpts(X,Y);
%    [NX,mX,nX]=fc_linalg3D.dim3D(X);
%    [NY,mY,nY]=fc_linalg3D.dim3D(Y);
%    assert( nX==mY );
%    N=dim(1);
%  dim
%    C=zeros(N,mX,nY);
%    whos
  [getX,getY,N,dimX,dimY]=fc_linalg3D.getCpts(X,Y);
  assert( dimX(3)==dimY(2) );
  C=zeros(N,dimX(2),dimY(3));
  for k=1:N
    for i=1:dimX(2)
      for j=1:dimY(3)
        for l=1:dimX(3)
          C(k,i,j)=C(k,i,j)+getX(X,k,i,l)*getY(Y,k,l,j);
        end
      end
    end
  end
end
